/**
* Class for customer repro.
  */
import com.perforce.p4java.core.*;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

import java.util.Date;
import java.util.List;

import com.perforce.p4java.client.IClient;
import com.perforce.p4java.exception.RequestException;
import com.perforce.p4java.impl.generic.core.Stream;
import com.perforce.p4java.impl.generic.core.Changelist;
import com.perforce.p4java.impl.mapbased.server.Server;
import com.perforce.p4java.option.client.AddFilesOptions;
import com.perforce.p4java.server.IOptionsServer;
import com.perforce.p4java.option.client.IntegrateFilesOptions;
import com.perforce.p4java.impl.generic.core.file.FileSpec;
import com.perforce.p4java.option.client.EditFilesOptions;
import com.perforce.p4java.option.client.ResolveFilesAutoOptions;
import com.perforce.p4java.server.ServerFactory;
import com.perforce.p4java.server.IServerInfo;
import com.perforce.p4java.impl.generic.core.*;
import com.perforce.p4java.impl.generic.core.Stream.*;
import com.perforce.p4java.core.IStreamViewMapping.PathType;

import java.io.FileWriter;
import java.io.PrintWriter;

public class StreamTest extends P4JavaDemo
{
    //Variables we might/will need for resolving.
private String DEFAULT_DESCRIPTION = "A test stream";    
private String user;

//Constructor

public StreamTest()
{
super();
this.user = "Jen";
//hard-coded, could parse in to the constructor when TestStream instance created.
}

//getter and setter methods
public String getUser()
{
return this.user;
}
public void setUser(String aUser)
{
this.user = aUser;
}

    public void createStream()
    {
        try
        {       
//Create a Server object
//          IOptionsServer server = getOptionsServer(null, null);
IOptionsServer server = ServerFactory.getOptionsServer("p4java://localhost:1666", null);
//hard-coding in username for now.
            server.setUserName("Jen");
//          server.setUserName("jen");
            server.connect();
//          server.login(password);
//Get p4 info
                    IServerInfo info = server.getServerInfo();
System.out.println(info);
//Create a client object
            IClient client = server.getClient("winjen");
                server.setCurrentClient(client);

//Create the stream.
System.out.println("Creating new release stream");
       ViewMap<IStreamRemappedMapping> remappedView = new ViewMap<IStreamRemappedMapping>();
       StreamRemappedMapping entry = new StreamRemappedMapping();
       entry.setLeftRemapPath("mars/*");
       entry.setRightRemapPath("mars/xyz*");
       entry.setOrder(0);
       remappedView.addEntry(entry);

       ViewMap<IStreamIgnoredMapping> ignoredView = new ViewMap<IStreamIgnoredMapping>();
       StreamIgnoredMapping iEntry = new StreamIgnoredMapping();
       iEntry.setIgnorePath(".p4config");
       iEntry.setOrder(0);
       ignoredView.addEntry(iEntry);

       ViewMap<IStreamViewMapping> view = new ViewMap<IStreamViewMapping>();
       StreamViewMapping sEntry = new StreamViewMapping();
       sEntry.setPathType(PathType.SHARE);
       sEntry.setViewPath("...");
       sEntry.setOrder(0);
       view.addEntry(sEntry);

       IStream stream = new Stream();
       stream.setDescription("A simple stream");
       stream.setName("Simple dev stream");
       stream.setParent("//streamy/main");
       stream.setStream("//streamy/simple");
       stream.setOwnerName(user);
       stream.setType(IStreamSummary.Type.DEVELOPMENT);
       stream.setStreamView(view);
       stream.setRemappedView(remappedView);
       stream.setIgnoredView(ignoredView);
       String result = server.createStream(stream);
}
catch (RequestException rexc) {
			System.err.println(rexc.getDisplayString());
			rexc.printStackTrace();
		} catch (Exception exc) {
			System.err.println(exc.getLocalizedMessage());
			exc.printStackTrace();
		}
	}	
	
//End class
}